PRAGMA foreign_keys = ON;

CREATE TABLE IF NOT EXISTS encrypted_values (
       id INTEGER PRIMARY KEY AUTOINCREMENT,
       iv TEXT,
       ciphertext TEXT,
       mac TEXT
);

CREATE TABLE IF NOT EXISTS props(
       name TEXT NOT NULL PRIMARY KEY,
       value TEXT
);

CREATE TABLE IF NOT EXISTS encrypted_props(
       name TEXT NOT NULL PRIMARY KEY,
       encrypted_value INTEGER NOT NULL
);

CREATE TABLE IF NOT EXISTS accounts(
       id INTEGER PRIMARY KEY AUTOINCREMENT,
       server INTEGER NOT NULL,
       user INTEGER NOT NULL,
       password INTEGER NOT NULL
);

CREATE TABLE IF NOT EXISTS namespaces(
       id INTEGER PRIMARY KEY AUTOINCREMENT,
       name BLOB NOT NULL
);

CREATE TABLE IF NOT EXISTS notes(
       id INTEGER PRIMARY KEY AUTOINCREMENT,
       namespace INTEGER,
       category TEXT NOT NULL CHECK(category IN ('account', 'note')),
       title BLOB NOT NULL,
       value BLOB NOT NULL,
       FOREIGN KEY(namespace) REFERENCES namespaces(id)
);
